import { StatsLabels } from "./StatsLabels";
import { StatsSink, StatsCounter, StatsGauge, StatsHistogram, StatsMetricParams } from "./StatsSink";
import * as promClient from "prom-client";
export interface LabelledValue {
    labels: StatsLabels;
    value: number;
}
export declare class PrometheusStatsCounter implements StatsCounter {
    protected metric: promClient.Counter;
    constructor(metric: promClient.Counter);
    inc(labels: StatsLabels, value?: number): void;
    reset(labels: StatsLabels, value?: number): void;
}
export declare class PrometheusStatsGauge extends PrometheusStatsCounter implements StatsGauge {
    protected metric: promClient.Gauge;
    constructor(gauge: promClient.Gauge);
    dec(labels: StatsLabels, value?: number): void;
    set(labels: StatsLabels, value: number): void;
}
export declare class PrometheusStatsHistogram implements StatsHistogram {
    protected metric: promClient.Histogram;
    constructor(metric: promClient.Histogram);
    observe(labels: StatsLabels, value: number): void;
    startTimer(labels: StatsLabels): (labels?: promClient.labelValues) => void;
}
export interface PrometheusStatsSinkConfiguration {
    registry?: promClient.Registry;
}
export declare class PrometheusStatsSink implements StatsSink {
    private registry;
    private metrics;
    constructor(config?: PrometheusStatsSinkConfiguration);
    counter(params: StatsMetricParams): StatsCounter;
    gauge(params: StatsMetricParams): StatsGauge;
    histogram(params: StatsMetricParams): StatsHistogram;
    getMetrics(): string;
}
